## ignite.js

Ignite.js is a package to help design, implement and debug asynchronous software. It is
a framework that allows state machines to be described in a natural, understandable way within JavaScript.
It is focused on being quick and easy to use, whilst providing powerful tools to help
the design, implementation and deployment stages.

### Reasons to Use

-   Simplified asynchronous and behavioural design for node.js
    - Remove callbacks
    - Handle multiple EventEmitters easily
    - Allow structured system design
    - Fully asynchronous
-   Useful plug-ins to support common asynchronous patterns
    - node.js asynchronous functions
    - Parallel list handling (e.g. `reduce`, `map`, `each`)
    - Handling multiple machines
-   Easily create visual representations of the code (state diagrams and, coming soon,
     sequence diagrams)
-   Simply distribute the behaviour across multiple processes
-   Support tools to help design, debug and deploy

### Documentation

The full documentation is available [here](http://ignitejs.com/).

### Examples

There are a number of examples in the source tree, which are described [here](http://ignitejs.com/examples/)
