# Richard's JSM To-do List

## Core:

    - Async guards
    - Object and array based machine descriptions
    - Exception handling
    - Sub machine event propagation
    - Finish event sources
        - plugins
        - fire'd async functions
    - Augment EventEmitter.emit() to allow catch-all listener

## Plugins:

    - All async firings append arguments on the end of the actions.
    - Add 'decision' functions to detect, filter, etc.
    - Multiple sub-machines with synchronisation
    - fork'd worker process for 'work' states

  
## Tests:

    - Refactor and tidy tests
    - Tests for sub machine event propagation


## Helper apps

    - Add comments to jsmachine
    - Test mode
    - Vows mode
    - Expresso mode?
    
## Graphs:

    - Function signatures in dot output
    - Improve edge labels
    - Use new FnParse to extract return values

## Lint


# Open Issues

    - consider adding 'once' property to state machine generator functions
    - When writing stand-alone, reusable JS Machines where the intention is 
      that their main (but not only) use case is to be spawned by parent machines, 
      how should they communicate (i.e. by firing events) with the parent. See 
      examples/rss_example.js line 78 (fire.$parentevt('rss.feed', xml);) for
      example.
    - In general how can running machines be controlled from external non-JSMachine
      bits of code? Starting and/or stopping a process is a basic use case.
    - When a library provides it's functionality by supplying a constructor function
      that constructs objects containing asynchronous methods returning event emitters,
      how does the library fit into the current JSMachine framework. (e.g. node-static)
